		.segment "RSYNCDATA"
		.export _RasterSync
		.export _IrqSetup		
		.export _irqRand		
		.export _timer
		.export _timer2
		.GLOBAL SSSIRQ
		
MACHINE		= $EDE4		; NTSC=$05, PAL=$0C
VIC			= $9000		; start of Video Interface Chip registers

_RasterSync: 	.byte 0
_irqRand: 		.byte 22
_timer: 		.byte 0
_timer2: 		.byte 0

		.segment "RSYNC"

_IrqSetup:

		LDA MACHINE
		CMP #$05
		BEQ NTSC
		CMP #$0C
		BEQ PAL
READY:	JMP RESET		; not a VIC?
		;
		; NTSC setup
NTSC:	LDX #<@NTSC		; load the timer low-byte latches
		STX $9126
		LDX #>@NTSC
		LDA #$75		; raster line 234/235
		BNE IRQSYNC
@NTSC = $4243			; (261 * 65 - 2)
		;
		; PAL setup
PAL:	LDX #<@PAL		; load the timer low-byte latches
		STX $9126
		LDX #>@PAL
		LDA #$82		; raster line 260/261
		BNE IRQSYNC
@PAL = $5686			; (312 * 71 - 2)
		;
IRQSYNC:

		CMP VIC+$04
		BNE IRQSYNC
		STX $9125		; load T1 latch high, and transfer both bytes to T1 counter

		; Setup IRQ to our own handler which chains the SSS
		SEI
		LDX #<IRQHANDLER                ; allows for tear-free flipping
		LDY #>IRQHANDLER
		STX $0314
		STY $0315
		CLI

RESET:
		rts
		
IRQHANDLER:

		; trigger update when this interupt over...
		LDA #1
		STA _RasterSync

	    ; push a new random number
		lda _irqRand
		asl
		asl
		asl
		clc
		adc _irqRand
		clc ; note this second clc.
		adc #193
		sta _irqRand

		; jump to default kernal handler...
		inc _timer;
		inc _timer2;
		JMP SSSIRQ