		.include "VIC-SSS-MMX.h"

.export	_SSSINIT 
.export	_SSSCELL
.export	_SSSCLEAR
.export	_SSSPLOT
.export	_SSSPRINT
.export	_SSSPRINTF
.export	_SSSPEEK		
.export	_SSSPEEKXY
.export	_SSSPOKE		
.export	_SSSCREATE	
.export _SSSUSE		
.export	_SSSANIM		
.export	_SSSMOVEXY	
.export _SSSTOUCH	
.export	_SSSREFRESH	
.export _SSSFLIP

.export _PLAYFIELD
.export _PLAYCOLOR
.export _SPRITEDEF
.export _SPRITEX
.export _SPRITEY

.import		popa 
.importzp	ptr1, tmp1, tmp2

_PLAYFIELD = PLAYFIELD
_PLAYCOLOR = PLAYCOLOR
_SPRITEDEF = SPRITEDEF
_SPRITEX = SPRITEX
_SPRITEY = SPRITEY

_SSSINIT:
	jmp SSSINIT

; extern BYTE __fastcall_ SSSCREATE(BYTE spriteH, BYTE sd);
; pass Accumulator with the SPRITEDEF value (see HEADER)
; pass Y with the SPRITEH value (1-16)
; returns X with sprite index #0 thru SPRITEMAX-1
_SSSCREATE:
	pha
	jsr popa
	tay
	pla
	jsr SSSCREATE
	txa ; move x into A for 'c' return value
	rts

;*********************************************************************
; Software Sprite Stack CLEAR SCREEN
;
; Pass A with the character code to fill the PLAYFIELD buffer.
; Value in COLORCODE will be used to fill the PLAYCOLOR buffer.
;
; These changes will go into effect only after a call to SSSFLIP
;
_SSSCLEAR = SSSCLEAR

;*********************************************************************
; Software Sprite Stack PLOT CURSOR IN FRAME BUFFER
;
; SSSPLOT uses PLAYFIELD frame buffer.
; SSSPLOTS uses PENDING frame buffer.
;
; Pass X/Y with coordinate to put cursor.
;
_SSSPLOT:

	jsr PARAMSTOXY
	jmp SSSPLOT

_SSSPLOTS:

	jsr PARAMSTOXY
	jmp SSSPLOTS


;*********************************************************************
; Same as SPRINTS, but works with string passed in fastcall args a/x
_SSSPRINTF:
		STA VECTORFG
		STX VECTORFG+1
		LDY #$00
@loop:	LDA (VECTORFG),Y
		BEQ @fini
		CMP #$0D
		BNE @ctrl
		TYA
		PHA
		LDY CRSRROW
		INY
		LDX #0
		JSR SSSPLOT
		PLA
		TAY
		JMP @next
@ctrl:	CMP #$F0
		BCC @cont		; color code?
		AND #$0F		; filter for 16-colors
		STA COLORCODE	; 0=blk,1=wht,2=red,3=cyn,4=mag,5=grn,6=blu,7=yel
		JMP @next
@cont:	JSR SSSPRINT
@next:	INY
		BNE @loop
		INC VECTORFG+1
		BNE @loop
@fini:	
		RTS


;*********************************************************************
; Software Sprite Stack PRINT TO A FRAME BUFFER
;
; Like SSSPOKE, writes to current cursor, but also advances it to
; the right (with line/screen wrap) upon completion.
;
; All registers are preserved from this call, for common loop use.
;
_SSSPRINT = SSSPRINT


;*********************************************************************
; Software Sprite Stack READ FROM A FRAME BUFFER
;
; SSSPEEK reads from PLAYFIELD frame buffer.
; SSSPEEKS reads from PENDING frame buffer.
; SSSPEEKXY reads from PLAYFIELD frame buffer, using the sprite pixel
; coordinate system to determine X/Y cursor positioning.
;
; Pass X/Y with the coordinate to put cursor.
; CRSRCHAR and CRSRCOLOR are filled with values under cursor, with
; the former returned in Accumulator.
;
_SSSPEEK:
	jsr PARAMSTOXY
	jmp SSSPEEK

_SSSPEEKS:
	jsr PARAMSTOXY
	jmp SSSPEEKS

; pixel X/Y
_SSSPEEKXY:
	jsr PARAMSTOXY
	jmp SSSPEEKXY

;*********************************************************************
; Software Sprite Stack WRITE TO A FRAME BUFFER
;
; Pass Accumulator with character code to write to current cursor.
; COLORCODE is used to fill same space with that value.
;
_SSSPOKE = SSSPOKE

;*********************************************************************
; Software Sprite Stack FLIP ACTIVE / PENDING FRAME BUFFERS
;
; Pass Y with the number of vertical sync counts to wait for, or zero
; to make changes visible immediately.
;
; Only the current cursor position is preserved when completed.
;
; If user is holding RUN/STOP key down, the current video frame is
; paused until it is released.
;
_SSSFFLIP:
	tay
	jmp SSSFFLIP

; extern __fastcall_ SSSCREATE(BYTE spriteH, BYTE sd);
;
; Software Sprite Stack SELECT A SPRITE TO MANIPULATE
;
; pass X index with the SPRITES number (0 - <SPRITEMAX)
; preset values for sssNUM, sssX, sssY, sssBYTES, sssNEXT
;
_SSSUSE:
	tax
	jmp SSSUSE



;*********************************************************************
; Software Sprite Stack LOAD SPRITE BUFFER WITH NEW IMAGE DATA
;
; SSSUSE must be called prior to point to sprite register entry
; pass Accumulator with this sprite's color
; pass X,Y as the source image pointer
;
_SSSANIM:
	sta tmp1
	stx tmp2
	jsr popa
	ldx tmp1
    ldy tmp2
	jmp SSSANIM

;*********************************************************************
; Software Sprite Stack MOVE A SPRITE TO ABSOLUTE X,Y COORDINATES
;
; SSSUSE must be called prior to point to sprite register entry
; pass X,Y with the sprite coordinates
;
_SSSMOVEXY:
	jsr PARAMSTOXY
	jmp SSSMOVEXY

;*********************************************************************
; Software Sprite Stack FLAG A SPRITE FOR RENDERING
;
; Pass X with the sprite#
;
_SSSTOUCH:
	tax
	jmp SSSTOUCH


;*********************************************************************
; Software Sprite Stack FLAG ALL SPRITES FOR RENDERING
;
_SSSREFRESH = SSSREFRESH

;*********************************************************************
; Software Sprite Stack PROTECTED WRITE TO PENDING FRAME BUFFER
;
; Pass X/Y with a screen cell coordinate.
; Pass A with character code to write to PENDING screen buffer.
; COLORCODE is used to fill same space with that value.
;
_SSSCELL:
	pha
	jsr PARAMSTOXY
	pla
	jmp SSSCELL


_SSSFLIP:
	tay
	jmp SSSFLIP


PARAMSTOXY:

	pha
	jsr popa
	tax
	pla
	tay
	rts